<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px" @submit.native.prevent>
<!--      <el-form-item label="房间" prop="roomId">-->
<!--        <template>-->
<!--          <el-select v-model="queryParams.roomId" filterable placeholder="请选择">-->
<!--            <el-option-->
<!--              v-for="item in roomList"-->
<!--              :key="item.roomId"-->
<!--              :label="item.roomName"-->
<!--              :value="item.roomId">-->
<!--            </el-option>-->
<!--          </el-select>-->
<!--        </template>-->
<!--      </el-form-item>-->
      <el-form-item label="大楼" prop="buildingId">
        <template>
          <el-select v-model="queryParams.buildingId" filterable placeholder="请选择">
            <el-option
              v-for="item in buildingList"
              :key="item.buildingId"
              :label="item.buildingName"
              :value="item.buildingId">
            </el-option>
          </el-select>
        </template>
      </el-form-item>
      <el-form-item label="区域" prop="areaId">
        <template>
          <el-select v-model="queryParams.areaId" filterable placeholder="请选择">
            <el-option
              v-for="item in areaList"
              :key="item.areaId"
              :label="item.areaName"
              :value="item.areaId">
            </el-option>
          </el-select>
        </template>
      </el-form-item>
      <el-form-item label="园区" prop="parkId">
        <el-select v-model="queryParams.parkId" placeholder="请选择" clearable size="small">
          <el-option
            v-for="item in parkList"
            :key="item.parkId"
            :label="item.parkName"
            :value="item.parkId"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="名称" prop="equipmentName">
        <el-input
          v-model="queryParams.equipmentName"
          placeholder="请输入名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
<!--      <el-form-item label="二维坐标" prop="lngLat">-->
<!--        <el-input-->
<!--          v-model="queryParams.lngLat"-->
<!--          placeholder="请输入二维坐标"-->
<!--          clearable-->
<!--          size="small"-->
<!--          @keyup.enter.native="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
<!--      <el-form-item label="三维坐标" prop="rasterLngLat">-->
<!--        <el-input-->
<!--          v-model="queryParams.rasterLngLat"-->
<!--          placeholder="请输入三维坐标"-->
<!--          clearable-->
<!--          size="small"-->
<!--          @keyup.enter.native="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="类型" prop="typeId">
        <template>
          <el-select v-model="queryParams.typeId" filterable placeholder="请选择">
            <el-option
              v-for="item in equipmentTypeList"
              :key="item.typeId"
              :label="item.typeName"
              :value="item.typeId">
            </el-option>
          </el-select>
        </template>
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择状态" clearable size="small">
          <el-option
            v-for="dict in dict.type.equipment_info_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['info:equipmentInfo:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['info:equipmentInfo:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['info:equipmentInfo:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['info:equipmentInfo:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="equipmentInfoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="设备id" align="center" prop="equipmentId" />
      <el-table-column label="房间" align="center">
        <template slot-scope="scope">
          {{ getRoomName(scope.row.roomId) }}
        </template>
      </el-table-column>
      <el-table-column label="大楼" align="center">
        <template slot-scope="scope">
          {{ getBuildingName(scope.row.buildingId) }}
        </template>
      </el-table-column>
      <el-table-column label="区域" align="center">
        <template slot-scope="scope">
          {{ getAreaName(scope.row.areaId) }}
        </template>
      </el-table-column>
      <el-table-column label="名称" align="center" prop="equipmentName" />
      <el-table-column label="二维坐标" align="center" prop="lngLat" />
      <el-table-column label="三维坐标" align="center" prop="rasterLngLat" />
      <el-table-column label="类型" align="center">
        <template slot-scope="scope">
          {{ getEquipmentTypeName(scope.row.typeId) }}
        </template>
      </el-table-column>
      <el-table-column label="状态" align="center" prop="status">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.equipment_info_type" :value="scope.row.status"/>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="140">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['info:equipmentInfo:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['info:equipmentInfo:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改设备信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="类别" prop="typeId">
          <template>
            <el-select v-model="form.typeId" filterable placeholder="请选择">
              <el-option
                v-for="item in equipmentTypeList"
                :key="item.typeId"
                :label="item.typeName"
                :value="item.typeId">
              </el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item label="房间" prop="roomId">
          <template>
            <el-select v-model="form.roomId" filterable placeholder="请选择">
              <el-option
                v-for="item in roomList"
                :key="item.roomId"
                :label="item.roomName"
                :value="item.roomId">
              </el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item label="大楼" prop="buildingId">
          <template>
            <el-select v-model="form.buildingId" filterable placeholder="请选择">
              <el-option
                v-for="item in buildingList"
                :key="item.buildingId"
                :label="item.buildingName"
                :value="item.buildingId">
              </el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item label="区域" prop="areaId">
          <template>
            <el-select v-model="form.areaId" filterable placeholder="请选择">
              <el-option
                v-for="item in areaList"
                :key="item.areaId"
                :label="item.areaName"
                :value="item.areaId">
              </el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item label="园区" prop="parkId">
          <el-select v-model="form.parkId" placeholder="请选择" clearable size="small">
            <el-option
              v-for="item in parkList"
              :key="item.parkId"
              :label="item.parkName"
              :value="item.parkId"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="设备编号" prop="equipCode">
          <el-input v-model="form.equipCode" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="名称" prop="equipmentName">
          <el-input v-model="form.equipmentName" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="二维坐标" prop="lngLat">
          <el-input v-model="form.lngLat" placeholder="请输入二维坐标" />
        </el-form-item>
        <el-form-item label="三维坐标" prop="rasterLngLat">
          <el-input v-model="form.rasterLngLat" @focus="openditu">
            {{ form.rasterLngLat}}
          </el-input>
        </el-form-item>
        <el-form-item label="状态" prop="status">
          <el-select v-model="form.status" placeholder="请选择状态">
            <el-option
              v-for="dict in dict.type.equipment_info_type"
              :key="dict.value"
              :label="dict.label"
              :value="parseInt(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="使用状态" prop="status">
          <el-select v-model="form.deviceStatus" placeholder="请选择">
            <el-option
              v-for="dict in dict.type.device_status"
              :key="dict.value"
              :label="dict.label"
              :value="parseInt(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="品牌" prop="status">
          <el-select v-model="form.brand" placeholder="请选择">
            <el-option
              v-for="dict in dict.type.equip_brand"
              :key="dict.value"
              :label="dict.label"
              :value="parseInt(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="监控地址" prop="video">
          <el-input v-model="form.video" placeholder="请输入监控地址" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <el-dialog title="地图" :visible.sync="dialogVisible" width="80%">
      <div id='mainMap'>
        <div id="mapDiv" style="width:100%; height:700px">
        </div>
      </div>
      <input type="button" value="清除" @click='clearmian()' />
      <input type="button" value="标点工具" @click='openMarkTool()' />
      <span slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click='tijiao'>确定</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import { listEquipmentInfo, getEquipmentInfo, delEquipmentInfo, addEquipmentInfo, updateEquipmentInfo, exportEquipmentInfo } from "@/api/info/equipmentInfo";
import { listBuildingInfo, getBuildingInfo } from "@/api/info/buildingInfo";
import { listAreaInfo, getAreaInfo } from "@/api/info/areaInfo";
import { listRoomInfo, getRoomInfo } from "@/api/info/roomInfo";
import { listEquipmentType, getEquipmentType } from "@/api/type/equipmentType";
import { listParkInfo, getParkInfo, delParkInfo, addParkInfo, updateParkInfo, exportParkInfo } from "@/api/info/parkInfo";

export default {
  name: "EquipmentInfo",
  dicts: ['equipment_info_type', 'device_status', 'equip_brand'],
  data() {
    return {
      parkList: [],
      dialogVisible: false,
      map: null,
      handler: null,
      markPoints: '', // 保存标记点的坐标
      equipmentTypeList: [],
      areaList: [],
      roomList: [],
      buildingList: [],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 设备信息表格数据
      equipmentInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        roomId: null,
        buildingId: null,
        areaId: null,
        equipmentName: null,
        lngLat: null,
        rasterLngLat: null,
        typeName: null,
        status: null,
        parkId: null,
      },
      queryBuildingParams: {
        pageNum: 1,
        pageSize: 999999,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        equipmentId: [
          { required: true, message: "设备id不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getBuilding();
    this.getRoomList();
    this.getAreaList();
    this.getEquipmentTypeList();
    this.getParkList();

  },
  methods: {

    getParkList() {
      listParkInfo(this.queryBuildingParams).then(response => {
        this.parkList = response.data.list;
      });
    },


    // 销毁天地图
    destructionTMap ()  {
      if (this.map) {
        this.map = null;
        // 直接将节点给删掉
        console.log('1qsad');

        const parentEl = document.getElementById('mainMap');
        const cahildrenEl1 = document.getElementById('mapDiv');
        if(cahildrenEl1) parentEl.removeChild(cahildrenEl1);
        // 然后再手动将节点加进来
        const newCahildrenEl = document.createElement("div");
        newCahildrenEl.id = 'mapDiv'
        newCahildrenEl.style = 'height: 700px;width: 100%;'
        parentEl.appendChild(newCahildrenEl)
      }
    },

    tijiao() {
      console.log('多边形数据:', this.form.rasterLngLat);
      console.log('多边形数据:', this.markPoints);
      this.form.rasterLngLat = this.markPoints
      this.destructionTMap()
      this.dialogVisible = false;
    },

    clearmian() {
      if (this.handler) this.handler.close();
      this.map.clearOverLays(); // 清除所有覆盖物
      this.markPoints = ''; // 清除保存的标记点坐标
    },

    openMarkTool() {
      console.log("1111111111")
      if (this.handler) this.handler.close(); // 关闭之前的工具

      this.handler = new T.MarkTool(this.map); // 创建标点工具
      this.handler.open(); // 打开标点工具

      this.handler.on("mouseup", (e) => {
        let drawData1 = e.currentLnglat.lat+","+e.currentLnglat.lng;
        this.markPoints = drawData1;
      });

      this.handler.on("close", () => {
        // 标点工具关闭时的处理
        this.handler = null;
      });
    },


    openditu() {
      console.log('打开地图对话框');
      this.dialogVisible = true;
      this.$nextTick(() => {
        const T = window.T;
        const zoom = 12;
        this.map = new T.Map('mapDiv');
        this.map.centerAndZoom(new T.LngLat(103.96, 30.66), zoom);
        // 创建标注工具对象
        this.handler = new T.MarkTool(this.map);
        console.log('handler 初始化完成:', this.handler);
        console.log('kanknak1', this.form.rasterLngLat);
        let points = new T.LngLat();
        if (this.form.rasterLngLat) {
          const coordinates = this.form.rasterLngLat.split(',');
          points =  new T.LngLat(coordinates[1], coordinates[0]);
        }
        // 创建面对象
        console.log('kanknak2', points);
        const marker = new T.Marker(points);
        // 向地图上添加面
        this.map.addOverLay(marker);
      });
    },

    getEquipmentTypeName(typeId) {
      const type = this.equipmentTypeList.find(b => b.typeId === typeId);
      return type ? type.typeName : '未知';
    },

    getAreaName(areaId) {
      const area = this.areaList.find(b => b.areaId === areaId);
      return area ? area.areaName : '未知';
    },

    getRoomName(roomId) {
      const room = this.roomList.find(b => b.roomId === roomId);
      return room ? room.roomName : '未知';
    },

    getBuildingName(buildingId) {
      const building = this.buildingList.find(b => b.buildingId === buildingId);
      return building ? building.buildingName : '未知';
    },

    getEquipmentTypeList() {
      listEquipmentType(this.queryBuildingParams).then(response => {
        this.equipmentTypeList = response.data.list;
      });
    },

    getAreaList() {
      listAreaInfo(this.queryBuildingParams).then(response => {
        this.areaList = response.data.list;
      });
    },

    getRoomList() {
      listRoomInfo(this.queryBuildingParams).then(response => {
        this.roomList = response.data.list;
      });
    },

    getBuilding() {
      listBuildingInfo(this.queryBuildingParams).then(response => {
        this.buildingList = response.data.list;
      });
    },
    /** 查询设备信息列表 */
    getList() {
      this.loading = true;
      listEquipmentInfo(this.queryParams).then(response => {
        this.equipmentInfoList = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        equipmentId: null,
        typeId: null,
        roomId: null,
        buildingId: null,
        areaId: null,
        equipmentName: null,
        lngLat: null,
        rasterLngLat: null,
        typeName: null,
        status: null,
        brand: null,
        equipCode: null,
        parkId: null,

      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.equipmentId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加设备信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const equipmentId = row.equipmentId || this.ids
      getEquipmentInfo(equipmentId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改设备信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.equipmentId != null) {
            updateEquipmentInfo(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addEquipmentInfo(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const equipmentIds = row.equipmentId || this.ids;
      this.$modal.confirm('是否确认删除设备信息编号为"' + equipmentIds + '"的数据项？').then(function() {
        return delEquipmentInfo(equipmentIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$modal.confirm('是否确认导出所有设备信息数据项？').then(() => {
        this.exportLoading = true;
        return exportEquipmentInfo(queryParams);
      }).then(response => {
        this.$download.name(response.msg);
        this.exportLoading = false;
      }).catch(() => {});
    }
  }
};
</script>
